<template>
    <form @submit.prevent>
        <div class="form__header">
            <h1 class="form__title">Log in to ALTCOINS HUB</h1>
            <h2 class="form__clue">
                Don’t have an account?
                <router-link to="/register">Create account</router-link>
            </h2>
        </div>

        <div class="form__body">
            <div class="form__input">
                <AhInput
                    label="Email"
                    placeholder="Enter your email address"
                    v-model="email"
                />
                <HelpText v-show="v$.email?.$error" :error="v$.email?.$error">
                    {{ v$.email?.$errors[0]?.$message }}
                </HelpText>
            </div>
            <div class="form__input">
                <AhInput
                    label="Password"
                    type="password"
                    placeholder="Enter your password"
                    v-model="password"
                    v-model:is-visible="isPasswordVisible"
                    visibility-control
                />
                <HelpText v-show="v$.password?.$error" :error="v$.password?.$error">
                    {{ v$.password?.$errors[0]?.$message }}
                </HelpText>
            </div>
            <div class="form__buttons">
                <div class="form__button">
                    <AhButton @click.stop="login">
                        Continue
                    </AhButton>
                </div>
                <router-link to="/forgot" class="form__link">Forgot password?</router-link>
            </div>
        </div>
    </form>
</template>

<script>

import AhInput from "@/components/AhInput";
import AhButton from "@/components/AhButton";
import HelpText from "@/components/HelpText";
import useVuelidate from "@vuelidate/core";
import {email, helpers, required} from "@vuelidate/validators";

export default {
    name: "LoginPage",
    components: {AhButton, AhInput, HelpText},
    setup() {
        return {v$: useVuelidate()}
    },
    data() {
        return {
            email: null,
            password: null,
            isPasswordVisible: false
        }
    },
    methods: {
        login() {
            return this.v$.$validate()
                .then(isValid => {
                    if (!isValid) {
                        return Promise.reject();
                    }
                    this.$router.push({name: '2fa'});
                })
                .catch(err => {
                    console.log(err);
                });
        }
    },
    validations() {
        return {
            email: {
                required: helpers.withMessage('Please enter your email', required),
                email: helpers.withMessage('Email format is incorrect', email),
            },
            password: {
                required: helpers.withMessage('Please enter your password', required)
            }
        }
    },
}

</script>

<style lang="scss" scoped>

form {
    max-width: 400px;

    display: flex;
    flex-direction: column;
    justify-items: center;
}

.form__title {
    font-family: 'Lato', sans-serif;
    font-style: normal;
    font-weight: 700;
    font-size: 50px;
    line-height: 60px;
    margin-bottom: 0px;
    min-width: 579px;

    color: #FFFFFF;
}

.form__clue {
    font-family: 'Inter', sans-serif;
    font-style: normal;
    font-weight: 500;
    font-size: 16px;
    line-height: 140%;
    margin: 11px 0 20px 0;

    color: #FFFFFF;

}

.form__clue a {
    color: $hsl-color-orange
}

.form__header {
    display: flex;
    flex-direction: column;
    justify-content: center;
    align-items: center;
}

.form__input {
    padding-bottom: 24px;
}

.form__buttons {
    display: flex;
    justify-content: center;
    flex-direction: column;
    align-items: center;
}

.form__link {

    font-family: 'Inter', sans-serif;
    font-style: normal;
    font-weight: 500;
    font-size: 14px;
    line-height: 17px;

    display: flex;
    align-items: center;
    text-align: center;
    text-decoration-line: underline;

    margin-top: 24px;
    color: #FFDA3E;

}

</style>